import { normalizeComponent } from 'vue-runtime-helpers';

//
//
//
//
//
//
//

var script = {
    name: 'AutosizeInput',

    inheritAttrs: false,

    props: {
        value: {
            required: true
        }
    },

    computed: {
        /**
         * Forward all parent event listeners and override
         * the input listener default behavior
         *
         * @return {Object}
         */
        listeners () {
            const input = (event) => {
                this.$emit('input', event.target.value);
            };

            return { ...this.$listeners, input }
        }
    }
};

/* script */
const __vue_script__ = script;

/* template */
var __vue_render__ = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("label", { staticClass: "v-autosize-input__container" }, [
    _c("div", {
      staticClass: "v-autosize-input__shadow",
      attrs: { tabindex: "-1" },
      domProps: { textContent: _vm._s(_vm.value) }
    }),
    _vm._v(" "),
    _c(
      "input",
      _vm._g(
        _vm._b(
          {
            ref: "input",
            staticClass: "v-autosize-input__field",
            attrs: { type: "text" },
            domProps: { value: _vm.value }
          },
          "input",
          _vm.$attrs,
          false
        ),
        _vm.listeners
      )
    )
  ])
};
var __vue_staticRenderFns__ = [];
__vue_render__._withStripped = true;

  /* style */
  const __vue_inject_styles__ = undefined;
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  var AutosizeInput = normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//

var script$1 = {
    name: 'AutosizeTextarea',

    props: {
        value: {
            required: true
        }
    },

    data: () => ({
        styles: {}
    }),

    computed: {
        /**
         * Forward all parent event listeners and override
         * the input listener default behavior
         *
         * @return {Object}
         */
        listeners () {
            const input = (event) => {
                this.resize(event);
                this.$emit('input', event.target.value);
            };

            return { ...this.$listeners, input }
        }
    },

    mounted () {
        this.$nextTick(_ => {
            this.styles = { 'height': `${this.$el.scrollHeight}px` };
        });
    },

    methods: {
        /**
         * Updates the textarea height
         *
         * @param  {Object} event.target
         * @return {void}
         */
        resize ({ target }) {
            target.style.height = 'auto';
            target.style.height = `${target.scrollHeight}px`;
        }
    }
};

/* script */
const __vue_script__$1 = script$1;

/* template */
var __vue_render__$1 = function() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "textarea",
    _vm._g(
      _vm._b(
        {
          staticClass: "v-autosize-textarea",
          style: _vm.styles,
          domProps: { value: _vm.value }
        },
        "textarea",
        _vm.$attrs,
        false
      ),
      _vm.listeners
    )
  )
};
var __vue_staticRenderFns__$1 = [];
__vue_render__$1._withStripped = true;

  /* style */
  const __vue_inject_styles__$1 = undefined;
  /* scoped */
  const __vue_scope_id__$1 = undefined;
  /* module identifier */
  const __vue_module_identifier__$1 = undefined;
  /* functional template */
  const __vue_is_functional_template__$1 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  var AutosizeTextarea = normalizeComponent(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    false,
    undefined,
    undefined,
    undefined
  );

const install = Vue => {
    Vue.component(AutosizeInput.name, AutosizeInput);
    Vue.component(AutosizeTextarea.name, AutosizeTextarea);
};

if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(plugin);
}

export default install;
export { AutosizeInput, AutosizeTextarea };
