(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = global || self, factory(global['vue-autosizer'] = {}));
}(this, (function (exports) { 'use strict';

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(source, true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(source).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  //
  //
  //
  //
  //
  //
  //
  var script = {
    name: 'AutosizeInput',
    inheritAttrs: false,
    props: {
      value: {
        required: true
      }
    },
    computed: {
      /**
       * Forward all parent event listeners and override
       * the input listener default behavior
       *
       * @return {Object}
       */
      listeners: function listeners() {
        var _this = this;

        var input = function input(event) {
          _this.$emit('input', event.target.value);
        };

        return _objectSpread2({}, this.$listeners, {
          input: input
        });
      }
    }
  };

  function unwrapExports (x) {
  	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var dist = createCommonjsModule(function (module, exports) {

  Object.defineProperty(exports, '__esModule', { value: true });

  function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
  /* server only */
  , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
      createInjectorSSR = createInjector;
      createInjector = shadowMode;
      shadowMode = false;
    } // Vue.extend constructor export interop.


    var options = typeof script === 'function' ? script.options : script; // render functions

    if (template && template.render) {
      options.render = template.render;
      options.staticRenderFns = template.staticRenderFns;
      options._compiled = true; // functional template

      if (isFunctionalTemplate) {
        options.functional = true;
      }
    } // scopedId


    if (scopeId) {
      options._scopeId = scopeId;
    }

    var hook;

    if (moduleIdentifier) {
      // server build
      hook = function hook(context) {
        // 2.3 injection
        context = context || // cached call
        this.$vnode && this.$vnode.ssrContext || // stateful
        this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
        // 2.2 with runInNewContext: true

        if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
          context = __VUE_SSR_CONTEXT__;
        } // inject component styles


        if (style) {
          style.call(this, createInjectorSSR(context));
        } // register component module identifier for async chunk inference


        if (context && context._registeredComponents) {
          context._registeredComponents.add(moduleIdentifier);
        }
      }; // used by ssr in case component is cached and beforeCreate
      // never gets called


      options._ssrRegister = hook;
    } else if (style) {
      hook = shadowMode ? function (context) {
        style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
      } : function (context) {
        style.call(this, createInjector(context));
      };
    }

    if (hook) {
      if (options.functional) {
        // register for functional component in vue file
        var originalRender = options.render;

        options.render = function renderWithStyleInjection(h, context) {
          hook.call(context);
          return originalRender(h, context);
        };
      } else {
        // inject component registration as beforeCreate hook
        var existing = options.beforeCreate;
        options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
      }
    }

    return script;
  }

  var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
  function createInjector(context) {
    return function (id, style) {
      return addStyle(id, style);
    };
  }
  var HEAD;
  var styles = {};

  function addStyle(id, css) {
    var group = isOldIE ? css.media || 'default' : id;
    var style = styles[group] || (styles[group] = {
      ids: new Set(),
      styles: []
    });

    if (!style.ids.has(id)) {
      style.ids.add(id);
      var code = css.source;

      if (css.map) {
        // https://developer.chrome.com/devtools/docs/javascript-debugging
        // this makes source maps inside style tags work properly in Chrome
        code += '\n/*# sourceURL=' + css.map.sources[0] + ' */'; // http://stackoverflow.com/a/26603875

        code += '\n/*# sourceMappingURL=data:application/json;base64,' + btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) + ' */';
      }

      if (!style.element) {
        style.element = document.createElement('style');
        style.element.type = 'text/css';
        if (css.media) style.element.setAttribute('media', css.media);

        if (HEAD === undefined) {
          HEAD = document.head || document.getElementsByTagName('head')[0];
        }

        HEAD.appendChild(style.element);
      }

      if ('styleSheet' in style.element) {
        style.styles.push(code);
        style.element.styleSheet.cssText = style.styles.filter(Boolean).join('\n');
      } else {
        var index = style.ids.size - 1;
        var textNode = document.createTextNode(code);
        var nodes = style.element.childNodes;
        if (nodes[index]) style.element.removeChild(nodes[index]);
        if (nodes.length) style.element.insertBefore(textNode, nodes[index]);else style.element.appendChild(textNode);
      }
    }
  }

  function createInjectorSSR(context) {
    if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
      context = __VUE_SSR_CONTEXT__;
    }

    if (!context) return function () {};

    if (!('styles' in context)) {
      context._styles = context._styles || {};
      Object.defineProperty(context, 'styles', {
        enumerable: true,
        get: function get() {
          return context._renderStyles(context._styles);
        }
      });
      context._renderStyles = context._renderStyles || renderStyles;
    }

    return function (id, style) {
      return addStyle$1(id, style, context);
    };
  }

  function addStyle$1(id, css, context) {
    var group = process.env.NODE_ENV === 'production' ? css.media || 'default' : id;
    var style = context._styles[group] || (context._styles[group] = {
      ids: [],
      css: ''
    });

    if (!style.ids.includes(id)) {
      style.media = css.media;
      style.ids.push(id);
      var code = css.source;

      if (process.env.NODE_ENV !== 'production' && css.map) {
        // https://developer.chrome.com/devtools/docs/javascript-debugging
        // this makes source maps inside style tags work properly in Chrome
        code += '\n/*# sourceURL=' + css.map.sources[0] + ' */'; // http://stackoverflow.com/a/26603875

        code += '\n/*# sourceMappingURL=data:application/json;base64,' + Buffer.from(unescape(encodeURIComponent(JSON.stringify(css.map)))).toString('base64') + ' */';
      }

      style.css += code + '\n';
    }
  }

  function renderStyles(styles) {
    var css = '';

    for (var key in styles) {
      var style = styles[key];
      css += '<style data-vue-ssr-id="' + Array.from(style.ids).join(' ') + '"' + (style.media ? ' media="' + style.media + '"' : '') + '>' + style.css + '</style>';
    }

    return css;
  }

  function createInjector$1(context, shadowRoot) {
    return function (id, style) {
      return addStyle$2(style, shadowRoot);
    };
  }

  function createStyleElement(shadowRoot) {
    var styleElement = document.createElement('style');
    styleElement.type = 'text/css';
    shadowRoot.appendChild(styleElement);
    return styleElement;
  }

  function addStyle$2(css, shadowRoot) {
    var styleElement = createStyleElement(shadowRoot);
    if (css.media) styleElement.setAttribute('media', css.media);

    if ('styleSheet' in styleElement) {
      styleElement.styleSheet.cssText = css.source;
    } else {
      while (styleElement.firstChild) {
        styleElement.removeChild(styleElement.firstChild);
      }

      styleElement.appendChild(document.createTextNode(css.source));
    }
  }

  exports.normalizeComponent = normalizeComponent;
  exports.createInjector = createInjector;
  exports.createInjectorSSR = createInjectorSSR;
  exports.createInjectorShadow = createInjector$1;

  });

  unwrapExports(dist);
  var dist_1 = dist.normalizeComponent;
  var dist_2 = dist.createInjector;
  var dist_3 = dist.createInjectorSSR;
  var dist_4 = dist.createInjectorShadow;

  /* script */
  const __vue_script__ = script;

  /* template */
  var __vue_render__ = function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c("label", { staticClass: "v-autosize-input__container" }, [
      _c("div", {
        staticClass: "v-autosize-input__shadow",
        attrs: { tabindex: "-1" },
        domProps: { textContent: _vm._s(_vm.value) }
      }),
      _vm._v(" "),
      _c(
        "input",
        _vm._g(
          _vm._b(
            {
              ref: "input",
              staticClass: "v-autosize-input__field",
              attrs: { type: "text" },
              domProps: { value: _vm.value }
            },
            "input",
            _vm.$attrs,
            false
          ),
          _vm.listeners
        )
      )
    ])
  };
  var __vue_staticRenderFns__ = [];
  __vue_render__._withStripped = true;

    /* style */
    const __vue_inject_styles__ = undefined;
    /* scoped */
    const __vue_scope_id__ = undefined;
    /* module identifier */
    const __vue_module_identifier__ = undefined;
    /* functional template */
    const __vue_is_functional_template__ = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    var AutosizeInput = dist_1(
      { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
      __vue_inject_styles__,
      __vue_script__,
      __vue_scope_id__,
      __vue_is_functional_template__,
      __vue_module_identifier__,
      false,
      undefined,
      undefined,
      undefined
    );

  //
  //
  //
  //
  var script$1 = {
    name: 'AutosizeTextarea',
    props: {
      value: {
        required: true
      }
    },
    data: function data() {
      return {
        styles: {}
      };
    },
    computed: {
      /**
       * Forward all parent event listeners and override
       * the input listener default behavior
       *
       * @return {Object}
       */
      listeners: function listeners() {
        var _this = this;

        var input = function input(event) {
          _this.resize(event);

          _this.$emit('input', event.target.value);
        };

        return _objectSpread2({}, this.$listeners, {
          input: input
        });
      }
    },
    mounted: function mounted() {
      var _this2 = this;

      this.$nextTick(function (_) {
        _this2.styles = {
          'height': "".concat(_this2.$el.scrollHeight, "px")
        };
      });
    },
    methods: {
      /**
       * Updates the textarea height
       *
       * @param  {Object} event.target
       * @return {void}
       */
      resize: function resize(_ref) {
        var target = _ref.target;
        target.style.height = 'auto';
        target.style.height = "".concat(target.scrollHeight, "px");
      }
    }
  };

  /* script */
  const __vue_script__$1 = script$1;

  /* template */
  var __vue_render__$1 = function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c(
      "textarea",
      _vm._g(
        _vm._b(
          {
            staticClass: "v-autosize-textarea",
            style: _vm.styles,
            domProps: { value: _vm.value }
          },
          "textarea",
          _vm.$attrs,
          false
        ),
        _vm.listeners
      )
    )
  };
  var __vue_staticRenderFns__$1 = [];
  __vue_render__$1._withStripped = true;

    /* style */
    const __vue_inject_styles__$1 = undefined;
    /* scoped */
    const __vue_scope_id__$1 = undefined;
    /* module identifier */
    const __vue_module_identifier__$1 = undefined;
    /* functional template */
    const __vue_is_functional_template__$1 = false;
    /* style inject */
    
    /* style inject SSR */
    
    /* style inject shadow dom */
    

    
    var AutosizeTextarea = dist_1(
      { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
      __vue_inject_styles__$1,
      __vue_script__$1,
      __vue_scope_id__$1,
      __vue_is_functional_template__$1,
      __vue_module_identifier__$1,
      false,
      undefined,
      undefined,
      undefined
    );

  var install = function install(Vue) {
    Vue.component(AutosizeInput.name, AutosizeInput);
    Vue.component(AutosizeTextarea.name, AutosizeTextarea);
  };

  if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(plugin);
  }

  exports.AutosizeInput = AutosizeInput;
  exports.AutosizeTextarea = AutosizeTextarea;
  exports.default = install;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
